using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Management;

namespace WMIQuery
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

		void Log(string text)
		{
			if(textBox1.Text == "Searching...")
				textBox1.Text = string.Empty;

			textBox1.Text += string.Format("{0}\r\n", text);
		}

		void Search()
		{
			ManagementObjectSearcher searcher = new ManagementObjectSearcher(comboBox1.Text);

			int cursor = 0;
			int itemCursor = 0;

			foreach (ManagementObject wmi_HD in searcher.Get())
			{
				itemCursor++;
				Log(string.Format("-[ Item {0} ]-------------------------------------------------------------------", itemCursor));
				Application.DoEvents();

				foreach (PropertyData prop in wmi_HD.Properties)
				{
					cursor++;
					if (prop.Value is Array)
					{
						Log(string.Format("{0} [{1}]", prop.Name, prop.Type.ToString()));
						int i = 0;
						foreach (object obj in (Array)prop.Value)
						{
							i++;

							if (i > 10)
								break;

							Log(string.Format("> {0}", obj));
						}

					}
					else
						Log(string.Format("{0}: {1}", prop.Name, (prop.Value != null ? prop.Value : "-")));


					if (cursor % 20 == 0)
						Application.DoEvents();
				}

				Log("\r\n");
			}

			if (itemCursor == 0)
				Log("No items found");		
		}

		private void button2_Click(object sender, EventArgs e)
		{
			
			textBox1.Text = "Searching...";
			Application.DoEvents();

			try
			{
				Search();
			}
			catch (Exception ex)
			{
				Log("*** error ***\r\n\r\n" + ex.ToString());
#if DEBUG
				throw;
#endif
			}

		}
    }
}